<?php

class ArrayPieceQuantik implements ArrayAccess, Countable
{
    //attributs
    protected array $piecesQuantiks;

    //constructeurs
    public function __construct(){
        $this->piecesQuantiks = array();
    }


    //méthodes
    public function __toString():string
    {
        $str = "";
        foreach ($this->piecesQuantiks as $item) {
            $str.= $item::__toString().' ';
        }
        return $str;
    }

    public function getPieceQuantik(int $pos):PieceQuantik
    {
        return $this->piecesQuantiks[$pos];
    }

    public function setPieceQuantik(int $pos,PieceQuantik $pieceQuantik)
    {
        $this->piecesQuantiks[$pos] = $pieceQuantik;
    }

    public function addPieceQuantik(PieceQuantik $piece)
    {
        $this->piecesQuantiks[] = $piece;
    }

    public function removePieceQuanik(int $pos)
    {
        unset($this->piecesQuantiks[$pos]);
    }

    /**
     * @inheritDoc
     */
    public function offsetExists($offset)
    {
        
    }

    /**
     * @inheritDoc
     */
    public function offsetGet($offset)
    {
        // TODO: Implement offsetGet() method.
    }

    /**
     * @inheritDoc
     */
    public function offsetSet($offset, $value)
    {
        // TODO: Implement offsetSet() method.
    }

    /**
     * @inheritDoc
     */
    public function offsetUnset($offset)
    {
        // TODO: Implement offsetUnset() method.
    }

    public function count():int
    {
        return count($this->piecesQuantiks);
    }
}